
;***************************
;*  Infrared routines for  *
;*    Magnavox TV Remote   *
;* (Uses Philips SAA3010T  *
;*  controller chip)       *
;***************************

; By Jeff Frohwein

; Last edit 1-Jan-99

LENON   equ     29
LENOFF  equ     35

;LENON   equ     33
;LENOFF  equ     LENON


VolumeUp:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        ei
        ret

VolumeDown:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2
        call    IROn1
        ei
        ret

VolumeMute:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff2
        call    IROn1
        ei
        ret

PowerOnOff:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        ei
        ret

ChannelUp:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        ei
        ret

ChannelDown:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2
        call    IROn1
        ei
        ret

Digit0:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        ei
        ret

Digit1:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn1
        ei
        ret

Digit2:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn2
        ei
        ret

Digit3:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn1
        call    IROff1
        call    IROn1
        ei
        ret

Digit4:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn2
        call    IROff1
        call    IROn1
        ei
        ret

Digit5:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn2
        call    IROff2
        call    IROn1
        ei
        ret

Digit6:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn1
        call    IROff1
        call    IROn2
        ei
        ret

Digit7:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        ei
        ret

Digit8:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        ei
        ret

Digit9:
        di
        call    IROn1
        call    IROff1
        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff1
        call    IROn1
        call    IROff2

        call    IROn2
        call    IROff1
        call    IROn1
        call    IROff2
        call    IROn1
        ei
        ret

IROn1:
        ld      b,LENON
.loop:
        ld      a,1
        ld      [$ff56],a

        nop

        ld      a,0
        ld      [$ff56],a

        rept 14
        nop
        endr

        dec     b
        jr      nz,.loop

        ret


IROn2:
        ld      b,LENON*2
.loop:
        ld      a,1
        ld      [$ff56],a

        nop

        ld      a,0
        ld      [$ff56],a

        rept 14
        nop
        endr

        dec     b
        jr      nz,.loop

        ret

IROff1:
        ld      b,LENOFF-1
.loop:
        rept 25
        nop
        endr

        dec     b
        jr      nz,.loop

        rept 19
        nop
        endr

        ret

IROff2:
        ld      b,LENOFF*2-1
.loop:
        rept 25
        nop
        endr

        dec     b
        jr      nz,.loop

        rept 19
        nop
        endr

        ret


